
`timescale 1ns / 1ps
// synthesis translate_on
module lcd_com (
                   // inputs:
                    address,
                    read,
                    write,
                    writedata,
                   // outputs:
                    LCD_E,
                    LCD_RS,
                    LCD_RW,
                    LCD_data,
                    readdata
                 )
;

  output           LCD_E;
  output           LCD_RS;
  output           LCD_RW;
  inout   [  7: 0] LCD_data;

  output  [  7: 0] readdata;
  input   [  1: 0] address;
  input            read;
  input            write;
  input   [  7: 0] writedata;

  wire             LCD_E;
  wire             LCD_RS;
  wire             LCD_RW;
  wire    [  7: 0] LCD_data;
  wire    [  7: 0] readdata;
  assign LCD_RW = address[0];
  assign LCD_RS = address[1];
  assign LCD_E = read | write;
  assign LCD_data = (address[0]) ? 8'hzz : writedata;
  assign readdata = LCD_data;
  //control_slave, which is an e_avalon_slave

endmodule

