
#include "system.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"
#include <stdio.h>
#include <system.h>
#include <string.h>

#include "sys/alt_dma.h"
#include "sys/alt_flash.h"
#include "sys/alt_flash_dev.h"

#include "io.h"
#include "sys/alt_alarm.h"    
#include "alt_types.h"
#include "sys/alt_irq.h"
#include "oc_i2c_regs.h"
#include "avalon_TLC5620.h"

#include "unistd.h"
#include "ziku.h"
#include "LCD.H"
#include "PCF8563.h"

extern void I2CWaitTIP(alt_u32 base);
extern void InitI2C();

#define key IORD_ALTERA_AVALON_PIO_DATA(PIO_KEY_BASE)&0xf

alt_u8 led = 0x01; 
alt_u8 cont1,cont2; 
alt_u8 clean_lcd=1;
alt_u16 i;


void timer_ISR (void * context,alt_u32 id) //ʱж1//
    {    
   //   alt_u32 sec;
      led++;
      cont1++;
      cont2--;
      IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER_0_BASE, 0);//TO־   
      IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER_0_BASE, 0);       
      IOWR_ALTERA_AVALON_PIO_DATA(PIO_LED_BASE,led);
      IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER_0_BASE, 50000000&0xffff);
      IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER_0_BASE, 50000000>>16);
      IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER_0_BASE, ALTERA_AVALON_TIMER_CONTROL_ITO_MSK|ALTERA_AVALON_TIMER_CONTROL_START_MSK ); 
 
 }

char RowAddrP,PageAddrP;
void PS2_interrupts()//PS2жϷ
{
  // alt_irq_disable(PS2_0_IRQ);//رPS2ж
   alt_irq_context context=alt_irq_disable_all();
    alt_u16 kbdata;
  //  char RowAddrP,PageAddrP;
    if(clean_lcd)
     Lcd12864Clear(LCD_TRI_12864_0_BASE);
     clean_lcd=0;
     kbdata= IORD(PS2_0_BASE,0);
     usleep(20);
     IOWR_8DIRECT(SEG78LED_0_BASE,4,kbdata);//ʾ
     IOWR_8DIRECT(SEG78LED_0_BASE,5,kbdata>>4);
     IOWR_8DIRECT(SEG78LED_0_BASE,6,kbdata>>8);
     IOWR_8DIRECT(SEG78LED_0_BASE,7,kbdata>>12);
     printf("0x%2X \n",kbdata);
     if(++RowAddrP>=0)
      {
      if(RowAddrP<12 )/*ûг64(5*12)ʾһַռ5*/  
         DisChar(LCD_TRI_12864_0_BASE,PageAddrP,RowAddrP*5,(char)kbdata,1);
         else if(RowAddrP<24)   
           DisChar(LCD_TRI_12864_0_BASE,PageAddrP,(RowAddrP-12)*5,(char)kbdata,2);
           else /*ʾﵽҰߣʾһҳһ*/
            {
             DisChar(LCD_TRI_12864_0_BASE,PageAddrP+1,0,(char)kbdata,1);
             RowAddrP = -1;
             if(++PageAddrP>=8)            
               PageAddrP=0;
            }
      }
       // alt_irq_enable(PS2_0_IRQ);//꿪ж
       alt_irq_enable_all(context);
}

void beep_test()
  {
  int i;
 for(i=0;i<100;i++)
  {
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_BEEP_BASE,1);
    usleep(1000);
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_BEEP_BASE,0);
    usleep(1000);
  }
  usleep(50000);
  for(i=0;i<100;i++)
  {
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_BEEP_BASE,1);
    usleep(1000);
    IOWR_ALTERA_AVALON_PIO_DATA(PIO_BEEP_BASE,0);
    usleep(1000);
  }
 }


int main(void)
{ 
  alt_u8 j;
  alt_u8 keytemp=0x7;
  alt_irq_register(TIMER_0_IRQ,0, timer_ISR);
  IOWR_ALTERA_AVALON_TIMER_PERIODL(TIMER_0_BASE, 50000000&0xffff);
  IOWR_ALTERA_AVALON_TIMER_PERIODH(TIMER_0_BASE, 50000000>>16);
  IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER_0_BASE,
  ALTERA_AVALON_TIMER_CONTROL_ITO_MSK|ALTERA_AVALON_TIMER_CONTROL_START_MSK   ); 
  
  Lcd12864Init(LCD_TRI_12864_0_BASE);//LCD12864ʼ
  //Lcd12864Init(LCD_TRI_12864_0_BASE);//LCD12864ʼ
  Lcd12864Clear(LCD_TRI_12864_0_BASE);
  usleep(10000);

 /******************************************************/
  //I2CʼI2CٶΪ100K
  InitI2C(OC_I2C_MASTER_0_BASE, 100000, 0);
  usleep(10000);
  /******************************************************/
  //ʼDAΪ100K
  avalon_tlc5620_init(AVALON_TLC5620_0_BASE, 250, 0x0); 
  alt_u16  voltage,ad_data;
  alt_u8   da_data;
  /******************************************************/ 
 
//עPS2жϷ򣬲Զж
 alt_irq_register( PS2_0_IRQ, NULL, (void*)PS2_interrupts );
 
 beep_test();
 
 alt_u8 timebuff[16],data, time_data;//ʱݽݴ
 alt_u16 i;
 PCF8563_SET();

 //ϵͳʱӷ
 // alt_alarm_start (&timer0,alt_ticks_per_second(),timer_ISR,NULL) ;
  
 
 while(1)
  { 
   int si=IORD_ALTERA_AVALON_PIO_DATA(PIO_KEY_BASE)&0xf;
   if(si!=0xf)//м
     keytemp=si;
  switch(keytemp)
  {
    case 0x7:
    {
   Lcd12864Clear(LCD_TRI_12864_0_BASE);
   Dishaizi(LCD_TRI_12864_0_BASE,0,32,0,1,ziku1);//
   Dishaizi(LCD_TRI_12864_0_BASE,0,48,1,1,ziku1);//ӭ
   Dishaizi(LCD_TRI_12864_0_BASE,0,0 ,2,2,ziku1);//
   Dishaizi(LCD_TRI_12864_0_BASE,0,16,3,2,ziku1);//
      
   Dishaizi(LCD_TRI_12864_0_BASE,3,0 ,0,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,16,1,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,32,2,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,48,3,1,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,0 ,4,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,16,5,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,32,6,2,ziku2);//
   Dishaizi(LCD_TRI_12864_0_BASE,3,48,7,2,ziku2);//˾
   Disstring_line(LCD_TRI_12864_0_BASE,"http://www.m c u h x.com",24,6);
   
   LCD1602_writestring(LCD_TRI_1602_0_BASE, "!NiosII ON V50! ",1);
   printf("FPGA/SOPC-HXCT-V50 \n"); 
   keytemp = 0xfe;


   }break;
    case 0xb:{  //key2 PS2̲
                RowAddrP = 0;
                PageAddrP = 0;
                Lcd12864Clear(LCD_TRI_12864_0_BASE);
                Disstring(LCD_TRI_12864_0_BASE,"PS2_TEST",8,0,0,1);
                printf("PS2_TEST\n"); 
                Disstring(LCD_TRI_12864_0_BASE,"please input",12,0,0,2);
                IOWR(LCD12864_CS_BASE,0,0);
                LCD1602_writestring(LCD_TRI_1602_0_BASE, "PS2KEYBOARD_test",2);
                keytemp = 0xff;
                clean_lcd=1;
             }break;                       
             
    case 0xd: { //key4 LCD
              for(i=0;i<16;i++)
               {
                usleep(500);
                timebuff[i]=I2CReaddata(OC_I2C_MASTER_0_BASE, 0xa2,i);
                time_data = (*(timebuff+2)&0x0f)|0x30;   
               } 
              if(data!=time_data)//жǷ仯һһ
                {
                 data=time_data;
                 printf("time is:%x/%x/%x %x:%x:%x\n",*(timebuff+8),*(timebuff+7)&0x1f,*(timebuff+5)&0x3f,
                 *(timebuff+4)&0x3f,*(timebuff+3)&0x7f,*(timebuff+2)&0x7f);
                }
               }break;
   case 0xe: { //ADDA
                      /*ȡADתе*/
               ad_data=IORD_8DIRECT(ADC_TLC549_0_BASE,0)&0x00ff;
               /*תΪѹֵmv:2.5Vѹ,8λɼ*/
                voltage=2500*ad_data/256;
                printf("voltage = %4dmV\n",voltage);
                /*ɼĵѹֵʾ*/
                IOWR_8DIRECT(SEG78LED_0_BASE,0,voltage%10);
                IOWR_8DIRECT(SEG78LED_0_BASE,1,(voltage/10)%10);
                IOWR_8DIRECT(SEG78LED_0_BASE,2,(voltage/100)%10);
                IOWR_8DIRECT(SEG78LED_0_BASE,3,(voltage/1000)%10);
                /*DA,4ͨѹֵ*/
                avalon_tlc5620_change_data(AVALON_TLC5620_0_BASE , 0x0|da_data++);
                usleep(1000);
                avalon_tlc5620_change_data(AVALON_TLC5620_0_BASE , 0x200|da_data);
                usleep(1000);
                avalon_tlc5620_change_data(AVALON_TLC5620_0_BASE , 0x400|da_data);
                usleep(1000);
                avalon_tlc5620_change_data(AVALON_TLC5620_0_BASE , 0x600|da_data);
                usleep(200000);
              }break;
   case 0xfe:
            {
             if(j!=cont1)
              {
               j=cont1;
              IOWR(LCD12864_CS_BASE,0,0);
              IOWR(LCD_TRI_1602_0_BASE,2,j%10|0x30);
               LCD1602_writestring(LCD_TRI_1602_0_BASE, " we do the best",2);
               printf("FPGA&SOPC from www.mcuhx.com\n");
              }
             IOWR_8DIRECT(SEG78LED_0_BASE,0,cont1%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,1,(cont1/10)%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,2,cont2%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,3,(cont2/10)%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,4,cont1%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,5,(cont1/10)%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,6,cont2%10);
             IOWR_8DIRECT(SEG78LED_0_BASE,7,(cont2/10)%10);
            } break;             
   case 0xff:break;           
     }
  }
}

 


